/*****************************************************************************
 * I2C Routinen fr PIC30.
 * Copyright 2007 Andreas Kaiser
 *****************************************************************************/

#ifndef I2C_H_
#define I2C_H_

#include <util/inttypes.h>

/*
 * Expects:
 *
 * I2C_RATE		I2c interface bitrate
 */

#define I2C_BUSY	0x01	// busy
#define I2C_ADDR_NAK	0x02	// address NAK
#define I2C_DATA_NAK	0x03	// data NAK

void	i2c_init (void);

// write to I2C device
// written byte stream is <addr,ctrl,data>
// return 0 on success, or some status
unsigned i2c_write(unsigned addr,
		   const uint8_t *ctrlBuf, unsigned ctrlLen,
		   const uint8_t *dataBuf, unsigned dataLen);


// read from I2C device
// written byte stream is <addr,ctrl>
// data returned is in <data>
// return 0 on success, or some status
unsigned i2c_read(unsigned addr,
		  const uint8_t *ctrlBuf, unsigned ctrlLen,
		        uint8_t *dataBuf, unsigned dataLen);

#endif //I2C_H_
